/* valaccodememberaccessbinding.vala
 *
 * Copyright (C) 2006-2008  Jürg Billeter, Raffaele Sandrini
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 *	Raffaele Sandrini <raffaele@sandrini.ch>
 */

#ifndef __GOBJECT_VALACCODEMEMBERACCESSBINDING_H__
#define __GOBJECT_VALACCODEMEMBERACCESSBINDING_H__

#include <glib.h>
#include <glib-object.h>
#include <vala/valamemberaccess.h>
#include <gobject/valaccodeexpressionbinding.h>
#include <gobject/valaccodegenerator.h>

G_BEGIN_DECLS


#define VALA_TYPE_CCODE_MEMBER_ACCESS_BINDING (vala_ccode_member_access_binding_get_type ())
#define VALA_CCODE_MEMBER_ACCESS_BINDING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_TYPE_CCODE_MEMBER_ACCESS_BINDING, ValaCCodeMemberAccessBinding))
#define VALA_CCODE_MEMBER_ACCESS_BINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALA_TYPE_CCODE_MEMBER_ACCESS_BINDING, ValaCCodeMemberAccessBindingClass))
#define VALA_IS_CCODE_MEMBER_ACCESS_BINDING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_TYPE_CCODE_MEMBER_ACCESS_BINDING))
#define VALA_IS_CCODE_MEMBER_ACCESS_BINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALA_TYPE_CCODE_MEMBER_ACCESS_BINDING))
#define VALA_CCODE_MEMBER_ACCESS_BINDING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALA_TYPE_CCODE_MEMBER_ACCESS_BINDING, ValaCCodeMemberAccessBindingClass))

typedef struct _ValaCCodeMemberAccessBinding ValaCCodeMemberAccessBinding;
typedef struct _ValaCCodeMemberAccessBindingClass ValaCCodeMemberAccessBindingClass;
typedef struct _ValaCCodeMemberAccessBindingPrivate ValaCCodeMemberAccessBindingPrivate;

struct _ValaCCodeMemberAccessBinding {
	ValaCCodeExpressionBinding parent_instance;
	ValaCCodeMemberAccessBindingPrivate * priv;
};

struct _ValaCCodeMemberAccessBindingClass {
	ValaCCodeExpressionBindingClass parent_class;
};


ValaCCodeMemberAccessBinding* vala_ccode_member_access_binding_new (ValaCCodeGenerator* codegen, ValaMemberAccess* member_access);
ValaMemberAccess* vala_ccode_member_access_binding_get_member_access (ValaCCodeMemberAccessBinding* self);
void vala_ccode_member_access_binding_set_member_access (ValaCCodeMemberAccessBinding* self, ValaMemberAccess* value);
GType vala_ccode_member_access_binding_get_type (void);


G_END_DECLS

#endif
