/* valagidlwriter.vala
 *
 * Copyright (C) 2008  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#ifndef __GOBJECT_VALAGIDLWRITER_H__
#define __GOBJECT_VALAGIDLWRITER_H__

#include <glib.h>
#include <glib-object.h>
#include <vala/valacodevisitor.h>
#include <vala/valacodecontext.h>
#include <stdlib.h>
#include <string.h>
#include <vala/valanamespace.h>
#include <vala/valaclass.h>
#include <vala/valastruct.h>
#include <vala/valainterface.h>
#include <vala/valaenum.h>
#include <vala/valaenumvalue.h>
#include <vala/valaerrordomain.h>
#include <vala/valaerrorcode.h>
#include <vala/valaconstant.h>
#include <vala/valafield.h>
#include <vala/valadelegate.h>
#include <vala/valamethod.h>
#include <vala/valacreationmethod.h>
#include <vala/valaproperty.h>
#include <vala/valasignal.h>

G_BEGIN_DECLS


#define VALA_TYPE_GIDL_WRITER (vala_gidl_writer_get_type ())
#define VALA_GIDL_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_TYPE_GIDL_WRITER, ValaGIdlWriter))
#define VALA_GIDL_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALA_TYPE_GIDL_WRITER, ValaGIdlWriterClass))
#define VALA_IS_GIDL_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_TYPE_GIDL_WRITER))
#define VALA_IS_GIDL_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALA_TYPE_GIDL_WRITER))
#define VALA_GIDL_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALA_TYPE_GIDL_WRITER, ValaGIdlWriterClass))

typedef struct _ValaGIdlWriter ValaGIdlWriter;
typedef struct _ValaGIdlWriterClass ValaGIdlWriterClass;
typedef struct _ValaGIdlWriterPrivate ValaGIdlWriterPrivate;

/**
 * Code visitor generating .gidl file for the public interface.
 */
struct _ValaGIdlWriter {
	ValaCodeVisitor parent_instance;
	ValaGIdlWriterPrivate * priv;
};

struct _ValaGIdlWriterClass {
	ValaCodeVisitorClass parent_class;
};


void vala_gidl_writer_write_file (ValaGIdlWriter* self, ValaCodeContext* context, const char* filename);
ValaGIdlWriter* vala_gidl_writer_new (void);
GType vala_gidl_writer_get_type (void);


G_END_DECLS

#endif
